import report
import Numeric
import util

def parsereport(report):
    labels = []
    intensity1 = []
    background1 = []
    intensity2 = []
    background2 = []
    infos = []
    for i in range(len(report.data)):
        fields = report.data[i]
        labels.append(fields[0])
        intensity1.append(eval(fields[1]))
        background1.append(eval(fields[2]))
        intensity2.append(eval(fields[4]))
        background2.append(eval(fields[5]))
        infos.append(fields[-1])
    return labels, Numeric.array(intensity1), Numeric.array(background1), Numeric.array(intensity2), Numeric.array(background2), infos

class Arraypair:
    def __init__(self, filename):
        report1 = report.Report(filename)
        self.labels = None
        self.intensity = [None, None]
        self.background = [None, None]
        self.labels, self.intensity[0], self.background[0], \
                     self.intensity[1], self.background[1], \
                     self.infos = parsereport(report1)
        
    def __getitem__(self, i):
        array = Array()
        array.labels = self.labels
        array.intensity = self.intensity[i]
        array.background = self.background[i]
        array.infos = self.infos
        return array
    
class Array:
    def __init__(self):
        self.labels = None
        self.intensity = None
        self.background = None
    def normalize(self):
        self.normal = 1.0 * self.intensity - self.background
        self.mean = util.mean(self.normal)
        self.normal = self.normal / self.mean
