#!/usr/bin/env python

import string

class Report:
 def __init__(self, filename):
    self.names = []
    self.data = []
    self.hash = {}
    self.parse(filename)

 def lookup(self, genecode):
   return self.data[self.hash[genecode]]

 def parse(self, filename):
   file = open(filename, "r")

   # read column names
   header = file.readline()
   header = string.rstrip(header)
   self.names = string.split(header, "\t")

   # read rest of file
   self.data = []
   index = 0
   for line in file.readlines():
     cols = string.split(string.rstrip(line), "\t")
     self.data.append(cols)
     self.hash[cols[0]] = index
     index = index + 1

   return self

# Test scaffold
if __name__ == '__main__':
  import sys
  report = Report(sys.argv[1])
  print report.names
  print "A01a =", report.data[report.hash['A01a']]
  print "D05f =", report.lookup('D05f')
